Update field mappings
- POST also PUT /{index}/_mapping
Add new fields to an existing data stream or index. You can use the update mapping API to:
- Add a new field to an existing index
- Update mappings for multiple indices in a single request
- Add new properties to an object field
- Enable multi-fields for an existing field
- Update supported mapping parameters
- Change a field's mapping using reindexing
- Rename a field using a field alias
Learn how to use the update mapping API with practical examples in the Update mapping API examples guide.
- Index privileges:
manage
Path Parameters
-
indexIndexName | IndexNamerequired -
A comma-separated list of index names the mapping should be added to (supports wildcards). Use
_allor omit to add the mapping on all indices.
Query Parameters
-
allow_no_indicesboolean · default: true A setting that does two separate checks on the index expression. If
false, the request returns an error (1) if any wildcard expression (including_alland*) resolves to zero matching indices or (2) if the complete set of resolved indices, aliases or data streams is empty after all expressions are evaluated. Iftrue, index expressions that resolve to no indices are allowed and the request returns an empty result.-
expand_wildcardsstring ExpandWildcards · default: open Type of index that wildcard patterns can match. If the request can target data streams, this argument determines whether wildcard expressions match hidden data streams. Supports comma-separated values, such as
open,hidden.Supported values include:
all: Match any data stream or index, including hidden ones.open: Match open, non-hidden indices. Also matches any non-hidden data stream.closed: Match closed, non-hidden indices. Also matches any non-hidden data stream. Data streams cannot be closed.hidden: Match hidden data streams and hidden indices. Must be combined withopen,closed, orboth.none: Wildcard expressions are not accepted.
-
Values:
allopenclosedhiddennone If
false, the request returns an error if it targets a concrete (non-wildcarded) index, alias, or data stream that is missing, closed, or otherwise unavailable. Iftrue, unavailable concrete targets are silently ignored.-
master_timeoutstring Duration · default: 30s Period to wait for a connection to the master node. If no response is received before the timeout expires, the request fails and returns an error.
-
timeoutstring Duration · default: 30s Period to wait for a response. If no response is received before the timeout expires, the request fails and returns an error.
-
write_index_onlyboolean · default: false If
true, the mappings are applied only to the current write index for the target.
Request
-
date_detectionboolean -
Controls whether dynamic date detection is enabled.
-
dynamicDynamicMapping -
Controls whether new fields are added dynamically.
-
Values:
strictruntimetruefalse -
dynamic_date_formatsstring -
If date detection is enabled then new string fields are checked against 'dynamic_date_formats' and if the value matches then a new date field is added instead of string.
-
dynamic_templatesstring to DynamicTemplate -
Specify dynamic templates for the mapping.
-
_field_namesFieldNamesField -
Control whether field names are enabled for the index.
-
enabledbooleanrequired -
_metaMetadata -
A mapping type can have custom meta data associated with it. These are not used at all by Elasticsearch, but can be used to store application-specific metadata.
-
numeric_detectionboolean · default: false -
Automatically map strings into numeric data types for all fields.
-
propertiesmap string to Property -
Mapping for a field. For new fields, this mapping can include:
- Field name
- Field data type
- Mapping parameters
-
_routingRoutingField -
Enable making a routing value required on indexed documents.
-
requiredbooleanrequired -
_sourceSourceField -
Control whether the _source field is enabled on the index.
-
enabledboolean -
excludesstring -
includesstring -
modeSourceFieldMode -
Supported values include:
disabledstoredcolumnar_storedsynthetic: Instead of storing source documents on disk exactly as you send them, Elasticsearch can reconstruct source content on the fly upon retrieval.
-
Values:
disabledstoredcolumnar_storedsynthetic -
runtimeRuntimeFields -
Mapping of runtime fields for the index.
Response
-
acknowledgedbooleanrequired -
For a successful response, this value is always true. On failure, an exception is returned instead.
-
_shardsShardStatistics -
failednumber uintrequired -
The number of shards the operation or search attempted to run on but failed.
-
successfulnumber uintrequired -
The number of shards the operation or search succeeded on.
-
totalnumber uintrequired -
The number of shards the operation or search will run on overall.
-
failuresShardFailure -
indexstring IndexName -
nodestring -
reasonErrorCauserequired -
typestringrequired -
The type of error
-
reasonstringnullable -
A human-readable explanation of the error, in English.
-
stack_tracestring -
The server stack trace. Present only if the
error_trace=trueparameter was sent with the request. -
caused_byErrorCause -
root_causeErrorCause -
suppressedErrorCause -
shardnumber -
statusstring -
primaryboolean -
skippednumber uint